	.include	doscall.mac
	.include	iocscall.mac



TVRAM	.equ	$e00000
GVRAM	.equ	$c00000
TPAL	.equ	$e82200
GPAL	.equ	$e82000
OPT2	.equ	3
XF5	.equ	1



	.text

PROGRAM_TOP:
	bra	MAIN

*===================================================================
OLD_B_KEYINP:
	.ds.l	1
	.dc.b	'T2GZ'
*===================================================================
T2GZ:
	movem.l	d0-d7/a0-a6,-(sp)

	btst	#OPT2,$800.w+$0e		* zbgL[Ă邩H
	beq	T2GZ_EXIT
	btst	#XF5,$800.w+$0b
	beq	T2GZ_EXIT

	move.w	#16-1,d0
	lea.l	TPAL,a0
	lea.l	GPAL,a1
@@:
	move.w	(a0)+,(a1)+
	dbra	d0,@b


* .d7.l = (int)i
* .d6.l = (int)j
* .d5.l = (int)k
* .d4.w = (unsigned short)code
* .d3.w = (unsigned short)plane3
* .d2.w = (unsigned short)plane2
* .d1.w = (unsigned short)plane1
* .d0.w = (unsigned short)plane0
* .a0.l = (unsigned short *)pointer
* .a1.l = GVRAM

	move.w	#512-1,d7
T2G_LOOP:
	move.w	d7,-(sp)
	move.w	d7,-(sp)
	lea.l	TVRAM,a0
	andi.l	#$0000ffff,d7
	move.l	#511,d0
	sub.l	d7,d0
	move.l	d0,d7
	lsl.l	#7,d7
	add.l	d7,a0				* pointer = (unsigned short *)(TVRAM+i*128)
	move.w	(sp)+,d7
	lea.l	GVRAM,a1
	andi.l	#$0000ffff,d7
	move.l	#511,d0
	sub.l	d7,d0
	move.l	d0,d7
	lsl.l	#8,d7
	lsl.l	#3,d7
	add.l	d7,a1				* gpointer = (unsigned short *)(GVRAM+i*2048)
	move.w	#48-1,d6
1:
	move.w	d6,-(sp)

	move.l	a0,-(sp)
	move.w	(a0),d0				* plane0 = *(pointer+TPLANE0)
	add.l	#$020000,a0
	move.w	(a0),d1				* plane1 = *(pointer+TPLANE1)
	add.l	#$020000,a0
	move.w	(a0),d2				* plane2 = *(pointer+TPLANE2)
	add.l	#$020000,a0
	move.w	(a0),d3				* plane3 = *(pointer+TPLANE3)
	move.l	(sp)+,a0
	addq.w	#2,a0

	move.w	#16-1,d5
@@:
	movem.w	d0-d3,-(sp)
	andi.w	#$8000,d0
	andi.w	#$8000,d1
	andi.w	#$8000,d2
	andi.w	#$8000,d3
	rol.w	#1,d0
	rol.w	#2,d1
	rol.w	#3,d2
	rol.w	#4,d3
	or.w	d1,d0
	or.w	d2,d0
	or.w	d3,d0
	andi.w	#$000f,d0
	move.w	d0,(a1)+			* (unsigned short *)gpointer
	movem.w	(sp)+,d0-d3
	lsl.w	#1,d0				* plane0 <<= 1
	lsl.w	#1,d1				* plane1 <<= 1
	lsl.w	#1,d2				* plane2 <<= 1
	lsl.w	#1,d3				* plane3 <<= 1
	dbra	d5,@b
	move.w	(sp)+,d6
	dbra	d6,1b

	move.w	(sp)+,d7
	dbra	d7,T2G_LOOP

T2GZ_EXIT:
	movem.l	(sp)+,d0-d7/a0-a6
	.dc.w	$4eb9
CALL_OLD_B_KEYINP:
	.dc.l	0

	rts

*===================================================================

MAIN:
	lea.l	WORK(pc),a6

	pea.l	TITLE(pc)
	DOS	_PRINT
	addq.l	#4,sp

	clr.l	-(sp)
	DOS	_SUPER
	addq.l	#4,sp
	move.l	d0,SSP_SAVE-WORK(a6)

	move.w	#$100,-(sp)
	DOS	_INTVCG
	addq.l	#2,sp
	move.l	d0,a0
	cmpi.l	#'T2GZ',-4(a0)
	beq	REMOVE

	lea.l	T2GZ(pc),a1
	move.w	#$100,d1
	IOCS	_B_INTVCS
	move.l	d0,OLD_B_KEYINP-WORK(a6)
	move.l	d0,CALL_OLD_B_KEYINP-WORK(a6)

	move.l	SSP_SAVE(pc),d0
	move.l	d0,-(sp)
	DOS	_SUPER
	addq.l	#4,sp

	pea.l	INSTALL_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

	clr.w	-(sp)
	move.l	#MAIN-PROGRAM_TOP,d0
	move.l	d0,-(sp)
	DOS	_KEEPPR


REMOVE:
	move.l	a0,-(sp)
	move.l	-8(a0),a1
	move.w	#$100,d1
	IOCS	_B_INTVCS
	move.l	(sp)+,a0
	suba.l	#T2GZ-PROGRAM_TOP,a0
	suba.l	#$f0,a0
	move.l	a0,-(sp)
	DOS	_MFREE

	pea.l	REMOVE_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp
	DOS	_EXIT

SSP_SAVE:
	.ds.l	1

	.even
	.data
WORK:

TITLE:
	.dc.b	't2gz 0.20 : Copyright 1997 Rampil.',13,10,0
INSTALL_MES:
	.dc.b	't2gz.r풓܂.',13,10,'OPT2+XF5T-VRAMG-VRAM֓]܂.',13,10,0
REMOVE_MES:
	.dc.b	't2gz.r풓܂.',13,10,0


	end

